package com.javacodegeeks.example;

import java.util.Arrays;
import java.util.HashMap;

import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.when;
import static org.mockito.Mockito.verify;

import com.atlassian.confluence.content.render.xhtml.ConversionContext;
import com.atlassian.confluence.spaces.Space;
import com.atlassian.confluence.spaces.SpaceManager;

@RunWith (MockitoJUnitRunner.class)
public class SpacesMacroTest {
	
	@Mock
    private SpaceManager spaceManager;
	
	@Mock
    private ConversionContext context;
	
	@Ignore
	@Test
	public void testBasicOperation() throws Exception {		
		Space space1 = new Space();
		space1.setName("Demonstration Space");
		Space space2 = new Space();
		space2.setName("Microsoft");
		Space space3 = new Space();
		space3.setName("Oracle");
		when(spaceManager.getAllSpaces()).thenReturn(Arrays.asList(space1, space2, space3));
		
		SpacesMacro macro = new SpacesMacro(spaceManager);
		
		String actual = macro.execute(new HashMap<String, String>(), "", context);
		
		String expected = "<ul><li>Demonstration Space</li><li>Microsoft</li><li>Oracle</li></ul>";
		
		verify(spaceManager).getAllSpaces();
		assertEquals(expected, actual);
	}

}
